import pandas as pd
from _typeshed import Incomplete
from solas_shared._config import Config as Config
from sqlalchemy.engine import Engine
from sqlalchemy.orm import Session

class Database:
    DB_URL: str | None
    FN_LEN: int
    ENUM_LEN: int
    LIST_LEN: int
    STR_LEN: int
    MED_STR_LEN: int
    LONG_STR_LEN: int
    ID_LEN: int
    CONN_URL_SQLITE_IN_MEM: str
    config: Incomplete
    mapper_registry: Incomplete
    version: Incomplete
    def __init__(self, config: Config, version: str) -> None: ...
    def set_db(self, db_url: str) -> None: ...
    @property
    def engine(self) -> Engine: ...
    @property
    def session(self) -> Session: ...
    def new_session(self) -> Session: ...
    @staticmethod
    def conn_url_posgresql(user: str, pw: str, network_path: str, database: str) -> str: ...
    @staticmethod
    def conn_url_mysql(user: str, pw: str, network_path: str, database: str) -> str: ...
    @staticmethod
    def conn_url_oracle(user: str, pw: str, network_path: str, database: str) -> str: ...
    @staticmethod
    def conn_url_mssql(user: str, pw: str, network_path: str, database: str) -> str: ...
    def build_schema(self, drop_all_existing: bool = False) -> None: ...
    def optimize(self) -> None: ...
    def sql_to_df(self, sql: str) -> pd.DataFrame: ...
